
================================================================================
FILE: transaction-banking/account-balances.mdx
================================================================================

---
title: Track Account Balances 
keywords:
  - txb
  - transaction banking
---

TxB APIs allow clients to track near real-time account balances. Clients use this service to get account balances before making a payment or get updated balances after a transaction is posted to their account.

## Step by step guide

#### Step 1 - Get a list of all accounts

Our account balances API provides information at an account level. So, our first step is to get a list of accounts associated with a TxB Client. 

`GET /v2/products` will return a list of accounts that the client currently uses.

```json
{
    "productList": [
        {
            "productType": "DEPOSIT_ACCOUNT",
            "relatedEntities": [
                        { ... }
                    ],
            "productTypeSpecificData": {
                "depositAccountSpecificData": {
                    "accountNumber": "220000008400",
                    "accountObject": {
                        "linkUrl": "https://api.test.txb.gs.com/v2/accounts/220000004004"
                    },
                    "transactionData": [
                        { ... }
                    ]
                }
            }
        },
        {
            "productType": "DEPOSIT_ACCOUNT",
            "relatedEntities": [
                        { ... }
                    ],
            "productTypeSpecificData": {
                "depositAccountSpecificData": {
                    "accountNumber": "110000008260",
                    "accountObject": {
                        "linkUrl": "https://api.test.txb.gs.com/v2/accounts/11008260"
                    },
                    "transactionData": [
                        { ... }
                    ]
                }
            }
        }
    ]
}
```

---

#### Step 2 — Identify the accounts you want to get balances for and fetch additional account identifiers

Once you have your product list response, determine account number(s) or IBAN(s) you would like to query and get additional account identifiers associated with them.

You can skip this step if you already have routing details for your account(s).

`GET /v2/accounts/220000004004` returns:

```json
{
    "type": "DEPOSIT_ACCOUNT",
    "accountStatus": "ACTIVE",
    "accountCurrency": "USD",
    "rate": 1,
    "branchCountry": "US",
    "administrative": { ... },
    "accountIdentifiers": {                           // returns account identifiers
        "accountNumber": "012345678910",
        "iban": "GB33GSLD01234567890123",             // returns IBAN
        "bankIdentifier": {
            "bic": "GOLDUS33TXB",
            "routingInfo": {                          // returns the Routing Number of the account
                "code": "USABA",
                "value": "124085260"
        }
        },
        "externalPaymentIds": [ ... ]
    },
    ...
}
```

Repeat this step for each of your products to get additional account identifiers.

---

#### Step 3: Get accountBalances for the list of identified TxB accounts

`POST /v1/reports/accountBalances`

with this request body:

```json

[
    {
        "accountNumber": "012345678910",
        "routingInfo": {
            "code": "USABA",
            "value": "124085260"
        },
        "iban" :"GB33GSLD01234567890120"
        }
]


```

returns the balance info for the account(s) including available and ledger balances

```json
[
    {
        "asOfDateTime": "2020-10-11T23:52:42.279Z",
        "accountIdentifiers": {...},
        "currency": "USD",
        "balances": [
            {
                "balanceType": "LEDGER",
                "startOfDayBalance": 2000.00,
                "endOfDayBalance": null,
                "currentBalance": 1500.00
            },
            {
                "balanceType": "AVAILABLE",
                "startOfDayBalance": 2000.00,
                "endOfDayBalance": null,
                "currentBalance": 1500.00
            }
        ]
    },
    {
        "asOfDateTime": "2020-10-11T23:52:42.279Z",
        "accountIdentifiers": {...},
        "currency": "GBP",
        "balances": [
            {
                "balanceType": "LEDGER",
                "startOfDayBalance": 5000.00,
                "endOfDayBalance": null,
                "currentBalance": 500.00
            },
            {
                "balanceType": "AVAILABLE",
                "startOfDayBalance": 5000.00,
                "endOfDayBalance": null,
                "currentBalance": 500.00
            }
        ]
    }
]

```



================================================================================
FILE: transaction-banking/account-transaction-data.mdx
================================================================================

---
title: Ledger Reporting
keywords:
  - txb
  - transaction banking
---

TxB APIs allow Clients to track real-time ledger activity. Clients use this service to understand what transactions have impacted their TxB account balance today (real-time, intraday) or on previous days (end of day, prior days).

## Step by step guide

#### Step 1 - Get a list of all referenceNumbers

Our ledger activities APIs provide information on an account or service level. So, our first step is to get a list of the accounts or services ('referenceNumbers') associated with a TxB Client.

<Info>

referenceNumber is the unique identifier of a TxB account or service

</Info>

`GET /v1/reports/transactionReports/reportReferences` will return a list of accounts or services that the Client currently uses. It returns 2 referenceNumbers, 1 for a deposit account and 1 for a payments only service.

```json
[
  {
    "referenceNumber": "123456789012",
    "referenceType": "DEPOSITACCOUNT", \\ can be Deposit Account or Payments Service Number
    "isVirtual": false
  },
  {
    "referenceNumber": "123456789011",
    "referenceType": "PAYMENTSONLY", \\ can be Deposit Account or Payments Service Number
    "isVirtual": false
  }
]
```

---

#### Step 2 - Get the transactionReport for the TxB deposit account

`GET /v2/reports/transactionReports?referenceNumber='123456789012'&businessDate='10-11-2020&limit=10'` returns the full balance info for the account and the first 10 transactions for the requested businessDate:

```json
{
  "asOfDateTime": "2020-10-11T23:52:42.279Z",
  "references": {
    "referenceNumber": "123456789012",  // aka  accountNumber
    "referenceType": "DEPOSITACCOUNT",
    "currency": "USD",
    "jurisdiction": "US",               // Identifies the country of the TxB Branch
    "referenceBank": {...},             // Identifies the BIC, Routing Number of the TxB account
    "isVirtual": false,
    "virtualAccountDetails": {          // shows virtual account hierarchy
     "parentAccountNumber": null,
     "physicalAccountNumber": null
    },

  "balances": [
    {
      "balanceType": "AVAILABLE",
      "startOfDayBalance": 2000,
      "endOfDayBalance": null,
      "currentBalance": 1000
    },
    {
      "balanceType": "LEDGER",
      "startOfDayBalance": 2000,
      "endOfDayBalance": null,
      "currentBalance": 1000
    }
  ],
  "transactions": [
    {
      "postingDate": "2020-10-11T16:52:42.279Z",
      "valueDate": "2020-10-11",
      "amount": 1000.00 ,
      "amountCurrency": "USD"
      "identifiers": {
        "gsUniquePaymentId": "Id_TxB_Created)",
        "paymentEndToEndId": "Id_You_Created"
        ...
      },
      "transactionType": "Outgoing Wire",
      "transactionTypeCode": {
        "domainCode": "PMNT",
        "familyCode": "ICDT",
        "subFamilyCode": "XBCT"
      },
      "linkedRecords": {...}             // E.g., returns link to the original payment
      ...
    }
    ...
  ],
  "hasMore": false
}
```

---

#### Step 3 - Interpret the data & repoll if necessary

Based on the data that we return, you will need to perform some analysis and figure out if there are any additional actions required

  * References object
    1. Use this section to understand how this account fits into a broader portfolio of accounts
    2. E.g., if this is a multi-currency account or virtual account, you may need to repeat this query on each virtual account to create a full view of transaction activity

  * Balances array
    1. Use this section to understand how much liquidity is available in the account 
    2. In this case, the `endOfDayBalance` is null, which means that the 'books' have not closed on the account for the day.  You may want to poll again at the end of the day (e.g., ~8pm EST) when `endOfDayBalance` is populated 
    3. The balances and transactions tie out as expected.  `balances[0].startOfDay` - `transactions[0].amount` = `balances[0].currentBalance`

  * Transactions array
    1. There is only 1 transaction available for this account on this `businessDate`. Note that `hasMore` equals `false`, so there aren't any additional pages of transactions to pull for this account
    2. Each transaction is uniquely identified by the gsUniquePaymentId (think of this as your transactionId)
    3. In most cases, 1 payment equals 1 transaction, e.g., if I make an outbound wire payment from TxB to another bank, this single wire payment will be reflected as a single transaction
    4. In other cases, 1 payment equals more than 1 transaction, e.g., if that same wire payment is returned by the receiving bank, then you will see two transactions in your account (1 for the payment and 1 for the return)
    5. In yet other cases, more than 1 payment equals 1 transaction, e.g., for bulk-processed payments (e.g., US ACH), all N payments within a payment batch will be treated as a single transaction 

<Grid layoutOption="oneColumn">
  <Block
    type="reference"
    title={'Reference materials'}
    body={'Learn more about common patterns and standards that TxB APIs use'}
    url={'/services/transaction-banking/standards'}
  />
</Grid>


================================================================================
FILE: transaction-banking/account-types.mdx
================================================================================

---
title: Account Types
keywords:
  - txb
  - transaction banking
---

TxB supports three different account structures / service types. In general, TxB APIs behave the same regardless of account / service type.

| Accounts                 | Description                                                                                                                                                                                                                                                                                                                                            |
| -------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| Payments-only service                  | Allows a Client to instruct TxB to move money from their existing non-TxB bank account to effect a payment to a beneficiary's bank account globally. No need to open a deposit account with TxB to take advantage of our payments stack                                                                                                                |
| Deposit account                        | A commercial bank account, which allows a Client to hold money with TxB and access our Payments services. Virtual accounts can be added to most TxB demand deposit accounts, so you can instantly scale up and down the number of virtual accounts you need |
| For Benefit Of ("FBO") deposit account | An FBO account is a segregated (client money) deposit account structure that enables 'embedded banking' by allowing the account holder to organize underlying virtual accounts for its eligible customers. Please [get in touch](/services/transaction-banking/contact-us) to learn more about how an FBO account can enable banking as a service      |


================================================================================
FILE: transaction-banking/ach-change-codes.mdx
================================================================================

---
title: Notification of Change Codes (NOCs)
keywords:
  - txb
  - transaction banking
---

This is a list of codes received from financial institutions and their explanation

|CODE|	DESCRIPTION|	CORRECTED DATA|
|:---|:----|:---|
|C01	|Incorrect DFI Account Number|	Correct DFI Account Number appears in first 17 positions of the Corrected Data Field|
|C02|	Incorrect Routing Number|	Correct Routing Number (including Check Digit) appears in first 9 positions of the Corrected Data Field.|
|C03|	Incorrect Routing Number and Incorrect DFI Account Number	|Correct Routing Number (including Check Digit) appears in first 9 positions of the Corrected Data Field--correct DFI Account Number appears in the 13th through 29th position of same field with a space in the 10th, 11th, and 12th positions.|
|C05|	Incorrect Transaction Code	|Correct Transaction Code appears in first 2 positions of the Corrected Data Field.
|C06	|Incorrect DFI Account Number and Incorrect Transaction Code|	Correct DFI Account Number appears in the first 17 positions of the Corrected Data Field — correct Transaction Code appears in the 21st and 22nd positions of the same field with spaces in the 18th, 19th, and 20th positions.|
|C07	|Incorrect Routing Number, Incorrect DFI Account Number, and Incorrect Transaction Code	|Correct Routing Number (including Check Digit) appears in the first 9 positions of the Corrected Data Field — correct DFI Account Number appears in the 10th through 26th positions of the same field — and correct Transaction Code appears in the 27th and 28th positions of the same field|
|C08|	Incorrect Receiving DFI Identification (IAT only)|	The correct Receiving DFI Identification appears in the first 34 positions of the Corrected Data Field.|
|C09	|Incorrect Individual Identification Number/Incorrect Receiver Identification Number|	Correct number appears in first 22 positions of the Corrected Data Field.
|C13	|Addenda Format Error	|Information in the Entry Detail Record was correct and the Entry was able to be processed and posted by the RDFI. However, information found in the Addenda Record was unclear or was formatted incorrectly|


================================================================================
FILE: transaction-banking/ach-file.mdx
================================================================================

---
title: ACH Payment File Structure 
keywords:
  - txb
  - transaction banking
---


## File Header Record — type 1 - all entries

The File Header record indicates specific file characteristics: the origin and destination of the file, the file creation date/time and other identification fields that allow the file to be identified uniquely.

| Field | Field Name |   Requirement| Contents Type | Length | Start Position | End Position |    
|:-------- | :------ | :-------| :-------| :-------| :-------| :-------|
| 1	| RECORD TYPE CODE |	Mandatory |	Always “1”	| 1 | 1 | 1 |
| 2	|PRIORITY CODE	|Mandatory|	Always “01”	|2	|2|	3|
|3	|IMMEDIATE DESTINATION|	Mandatory	|GS Bank routing number Always “b026015079”  (“b”= space)	|10|	4	|13|
|4|	IMMEDIATE ORIGIN	|Mandatory|	Client selected identifier that identifies the file or its source. The 3 fields (Immediate Origin, File Creation Date & File ID Modifier) uniquely identify a file as received by GS Bank|	10	|14	|23|
|5	|FILE CREATION DATE	|	Mandatory	|	Date in “YYMMDD”	|	6		|24		|29
|6|FILE CREATION TIME|	Mandatory|	Time in “HHMM”| 	4	|30	|33|
|7|	FILE ID MODIFIER|	Mandatory|	Upper case A-Z Numeric 0-9. Start with “A” for the first file of the day. Increment to “B”, “C”, and so on, up to “Z” (followed by “0” to “9”) for every subsequent file during the day|	1	|34	|34|
|8	|RECORD SIZE|	Mandatory	|Always “094”|	3	|35	|37|
|9|	BLOCKING FACTOR|	Mandatory|	Always “10”	|2|	38	|39|
|10|	FORMAT CODE|	Mandatory	|Always “1”	|1	|40|	40|
|11|	IMMEDIATE DESTINATION NAME|	Mandatory	|Always “GS BANK USA”|	23|	41|	63|
|12|	IMMEDIATE ORIGIN NAME|	Mandatory|	Alphanumeric. Sending organization name|	23|	64	|86|
|13|	REFERENCE CODE|	Optional|	Alphanumeric<br/>Optional for your reference. Ignored by GS Bank|	8	|87	|94|

File Header Record — Example   
<mark>1</mark>01 <mark>026015079</mark>1122334455<mark>200601</mark>1330<mark>A</mark>094<mark>10</mark>1<mark>GS &nbsp;&nbsp;&nbsp;BANK USA </mark>&nbsp;&nbsp;&nbsp; YOUR COMPANY NAME&nbsp;&nbsp;&nbsp;<mark>REF123AB</mark>

## Company / Batch Header Record — type 5 — for CCD, CTX, PPD, WEB and TEL entries

The Company / Batch Header record indicates key transaction attributes that are common to all entries contained in the batch. Among other things, it indicates the Originator, the Effective Entry Date (settlement / value date), a brief description of the purpose and the Standard Entry Class Code common to all transactions in the batch

|Field | Field Name |Requirement | Contents/Type | Length | Start Position | End Position|
| :----- | :----| :----| :---- |:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “5”|	1	|1|	1|
|2|	SERVICE CLASS CODE|	Mandatory|	Identifies the type of entries in the batch. Enter one of the following codes: <br/>* “200” — Batch containing ACH Credits and Debits <br/>* “220” — Batch containing ACH Credits only<br/>* “225” — Batch containing ACH Debits only|	3|	2|	4|
|3|	COMPANY NAME|	Mandatory|	Alphanumeric<br/> Your organization name. Under NACHA rules, this field identifies the source of the transaction to the receiver, generally must contain the name by which the originator (your organization) is known to and readily recognized by the receiver|	16	|5|	20|
|4|	COMPANY DISCRETIONARY DATA|	Optional|	Alphanumeric<br/>For your company’s internal use, if desired. No specific format is required|	20|	21|	40|
|5|	COMPANY IDENTIFICATION|	Mandatory|	Alphanumeric<br/>Enter the Company ID as agreed between GS Bank and yourself|	10	|41	|50|
|6|	STANDARD ENTRY CLASS CODE<sup>1</sup> |	Mandatory|	Alphanumeric<br/> Enter one of the following supported codes:<br/>* For ACH Credits: CCD, CTX, PPD <br/>* For ACH Debits: CCD, CTX, PPD, WEB, TEL	|3|	51|	53|
|7|	COMPANY ENTRY DESCRIPTION|	Mandatory|	Alphanumeric. Description of the purpose of the Entries in the batch that will be passed on to the receiver, e.g. PAYROLL, BILL PMT, etc.	|10	|54|	63|
|8|	COMPANY DESCRIPTIVE DATE|	Optional|	Alphanumeric<br/>Optional reference date that is passed on to the receiver for descriptive purposes, e.g. JAN 20, 011520. <br/>Note:- this date is not used for settlement or posting purposes.	|6|	64|	69|
|9|	EFFECTIVE ENTRY DATE|	Mandatory	|YYMMDD,<br/> Banking day on which settlement is to take place.<br/> Must be a valid date same as or up to 30 days in future from the date the file is received| 	6|	70|	75|
|10	|SETTLEMENT DATE (JULIAN)|	N/A	|Reserved. Fill with spaces|	3|76|	78|
|11|	ORIGINATOR STATUS CODE|	Mandatory|	Always “1”|	1	|79||	79|
|12	|ORIGINATING DFI IDENTIFICATION|	Mandatory|	Always “02601507” (first 8 digits of GS Bank’s routing number)|	8|	80|	87|
|13|	BATCH NUMBER|	Mandatory|	Numeric.<br/> Start with “0000001” and increment by 1 for each subsequent batch in the file|	7|	88|	94|

<sup>1</sup> See section on Standard Entry Class codes for a further description of supported codes

Company / Batch Header Record — Example 
<mark>5</mark>220<mark>ALPHA &nbsp;&nbsp;&nbsp;&nbsp;COMPANY</mark> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <mark>1234567890</mark>PPD<mark>PAYROLL</mark>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   JUN 20<mark>200701</mark>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  <mark>1</mark>02601507<mark>0000001</mark>

## Company / Batch Header Record — type 5 — for IAT entries 

The Company / Batch Header record indicates key transaction attributes that are common to all entries contained in the batch. Among other things, it indicates the Originator, the Effective Entry Date (settlement / value date), a brief description of the purpose and the Standard Entry Class Code common to all transactions in the batch

|Field | Field Name |Requirement | Contents/Type | Length | Start Position | End Position|
| :----- | :----| :----| :---- |:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “5”|	1	|1|	1|
|2|	SERVICE CLASS CODE|	Mandatory|	Identifies the type of entries in the batch. Enter one of the following codes: <br/>* “200” — Batch containing ACH Credits and Debits <br/>* “220” — Batch containing ACH Credits only<br/>* “225” — Batch containing ACH Debits only|	3|	2|	4|
|3|	IAT Indicator|	Optional|	Alphanumeric<br/> To be left blank|	16	|5|	20|
|4|	Foreign Exchange Indicator|	|	Alphanumeric<br/>Enter one of the following values<br/> This field contains a code used to indicate the foreign exchange conversion methodology applied to an IAT entry <br/> * “FV” (Fixed-to-Variable). Entry originated in a fixed-value amount and is to be received in a variable amount resulting from the execution of the foreign exchange conversion. <br/> * “VF” (Variable-to-Fixed). Entry originated in a variable-value amount based on a specific foreign exchange rate for conversion to a fixed-value amount in which the Entry is to be received.“FF” (Fixed-to-Fixed). Entry originated in a fixed-value amount and is to be received in the same fixed-value amount in the same currency denomination. There is no foreign exchange conversion for Entries Transmitted using this code. For Entries originated in a fixed-value amount, the Foreign Exchange Reference Field will be space filled.|	22|	21|	22|
|5|	FOREIGN EXCHANGE REFERENCE INDICATOR|	Conditional|	Populated if there was a foreign exchange conversion as indicated by the Foreign Exchange Indicator field (“FV” or “FF”), and indicates the content that follows in the Foreign Exchange Reference field. <br/>Possible values for this field are — <br/> * "1" - Foreign Exchange rate <br/> * "2" - Foreign Exchange Reference Number <br/> * "3" - Space Filled  |	1	|23	|23|
|6|	FOREIGN EXCHANGE REFERENCE |	Conditional|	Alphanumeric<br/> Additional information relating to the foreign exchange conversion. Populate FX rate or an FX reference number as indicated by the previous field. If the Foreign Exchange Indicator contains “FF”, this field will always be spaced filled.	|15|	24|	38|
|7|	ISO DESTINATION COUNTRY CODE|	Mandatory|	Alphanumeric. This field is currently not used by GS Bank. Fill with spaces.	|2	|39|	40|
|8|	ORIGINATOR IDENTIFICATION|	Mandatory|	Alphanumeric<br/>Enter the Company ID as agreed between GS Bank and yourself.	|10|	41|	50|
|9|	STANDARD ENTRY CLASS CODE|	Mandatory	|Alphanumeric. Always “IAT” for International ACH transactions| 	3|	51|	53|
|10	|COMPANY ENTRY DESCRIPTION| Mandatory	|Alphanumeric.<br/>Description of the purpose of the Entries in the batch that will be passed on to the receiver, e.g. PAYROLL, BILL PMT, etc.|	10|54|	63|
|11|ISO ORIGINATING CURRENCY CODE|	Mandatory|	Alphanumeric.3-character ISO currency code for the currency in which the Entry was first originated.|	3	|67||	69|
|12	|ISO DESTINATION CURRENCY CODE|	Mandatory|	Alphanumeric.3-character ISO currency code for the currency in which the Entry is to be received.|	3|	67|	69|
|13|	EFFECTIVE ENTRY DATE|	Mandatory|	YYMMDD.Banking day on which settlement is to take place. Must be a valid date same as or up to 30 days in future from the date the file is received. |	6|	70|	75|
|14	|SETTLEMENT DATE(JULIAN)|	N/A|	Reserved. Fill with spaces.|	3|	76|	78|
|15	|ORIGINATOR STATUS CODE|	Mandatory|	Always "1".|	1|	79|	79|
|16	|GATEWAY / ORIGINATING DFI IDENTIFICATION|	Mandatory|	Always “02601507” (first 8 digits of GS Bank’s routing number).|	8|	80|	87|
|17	|BATCH NUMBER|	Mandatory|	Numeric. Start with “0000001” and increment by 1 for each subsequent batch in the file..|	7|	88|	94|

<sup>1</sup> See section on Standard Entry Class codes for a further description of supported codes

Company / Batch Header Record — Example 
<mark>5</mark>220<mark>VF2FXREF-123456 &nbsp;&nbsp;&nbsp;&nbsp;</mark> US <mark>1234567890IATREMITTANCEGBPUSD200701</mark>PPD<mark>1026015070000001</mark>



## Entry Detail Record — type 6 — for CCD, PPD, WEB and TEL entries

The Entry Detail record provides information as relates to the Receiver of the transaction, specifically the account number and RDFI routing identifier and the amount. The field layout is largely consistent, but may vary for certain SEC codes. The below applies to CCD, PPD, WEB and TEL entries. Record structure for CTX and IAT entries is outlined in the next sections.

|Field | Field Name |Requirement | Contents/Type | Length | Start Position | End Position|
| :----- | :----| :----| :---- |:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “6”	|1|	1|	1|
|2	|TRANSACTION CODE|	Mandatory|	Numeric. Enter one of the following values:<br/>For Credits:<br/>* 22 — Checking account <br/>* 32 — Savings account <br/>* 23 — Checking account prenotification (zero-dollar)<br/>* 24 — Checking account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>* 33 — Savings account prenotification (zero-dollar)<br/>* 34 — Savings account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>For  Debits:<br/>* 27 — Checking account credit<br/>* 37 — Savings account credit<br/>* 28 — Checking account prenotification (zero-dollar)<br/>* 29 — Checking account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>* 38 — Savings account prenotification (zero-dollar)<br/>* 39 Zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>For Loan Credits:<br/>* 52 Loan Account <br/>* 53 Prenotification of Loan Account Credit (zero-dollar)<br/>* 54 Zero dollar with remittance data (for CCD and CTX Entries only)<br/>For Loan Debits: <br/>* 55 Loan Account Debit (Reversals Only)|2|	2	|3|
|3|	RECEIVING DFI  IDENTIFICATION|	Mandatory|	First 8 digits of the receiving depository financial institution (RDFI) routing number|	8|	4	|11|
|4|	CHECK DIGIT	|Mandatory|	Last digit of the receiving depository financial institution (RDFI) routing number|	1	|12|	12|
|5|	RECEIVER’S ACCOUNT NUMBER AT RDFI|	Mandatory	|Alphanumeric<br/> Receiver’s account number at the RDFI to be credited or debited|	17|	13|	29|
|6|	AMOUNT	|Mandatory|	Dollar and Cent<br/> Amount in dollars and cents. Must be unsigned, without a decimal point, right justified and filled with leading zeros. E.g. $230.56 is completed as 0000023056|	10|	30|	39|
|7|	(INDIVIDUAL) IDENTIFICATION NUMBER|	Optional|	Alphanumeric<br/>Additional identifying reference for the receiver. Do not use Social Security Number (SSN)|	15|	40|	54|
|8|	INDIVIDUAL / RECEIVING COMPANY NAME	|Mandatory|	Alphanumeric<br/>Receiver name (individual or business / company name)|	22|	55	|76|
|9|	DISCRETIONARY DATA (CCD, PPD) / <br/>PAYMENT TYPE CODE (WEB, TEL)|	Conditional	|Alphanumeric.<br/>For WEB and TEL entries, this field may contain:<br/>* “R” — for a recurring entry<br/>* “S” — for a single entry<br/>* “ST” — for standing instruction entry<br/>For CCD and PPD, this field is not used by GS Bank. Fill with spaces|	2|	77	|78|
|10|	ADDENDA RECORD INDICATOR|	Mandatory|	Numeric. Enter one of the following values:<br/>0 — no addenda record for this Entry<br/>1 — one or more addenda records follow this Entry|	1	|79	|79|
|11|	TRACE NUMBER|	Mandatory|	Numeric.<br/>Unique identifier for each Entry within the batch. The first 8 digits must correspond to GS Bank’s routing number “02601507”, followed by a sequence number in ascending order within the batch|15	|80|	94|

*Entry Detail Record — Example*  

<mark>6</mark>32<mark>11112222</mark>3<mark>123456789&nbsp;&nbsp;&nbsp;&nbsp;</mark>0000023062<mark>AB156325&nbsp;&nbsp;&nbsp;&nbsp;</mark>JACK SMITH&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<mark>&nbsp;&nbsp;&nbsp;</mark>0<mark>026015070000001</mark>

## Entry Detail Record — type 6 — for CTX entries

|Field | Field Name |Requirement | Contents/Type | Length | Start Position | End Position|
| :----- | :----| :----| :---- |:----|:----|:----|
|1	|RECORD TYPE CODE|	Mandatory|	Always “6”|	1	|1|	1|
|2	|TRANSACTION CODE|	Mandatory|	Numeric. Enter one of the following values:<br/>For Credits:<br/>* 22 — Checking account<br/>* 32 — Savings account<br/>* 23 — Checking account prenotification (zero-dollar)<br/>* 33 — Savings account prenotification (zero-dollar)<br/>* 24 — Checking account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>* 34 — Savings account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>For  Debits:<br/>* 27 — Checking account <br/>* 37 — Savings account <br/>* 28 — Checking account prenotification (zero-dollar)<br/>* 29 — Checking account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>* 38 — Savings account prenotification (zero-dollar)<br/>* 39 — Savings account zero dollar with remittance data (for CCD, CTX, and IAT Entries only)<br/>For Loan Credits:<br/>52 Loan Account <br/>53 Prenotification of Loan Account Credit (zero-dollar)<br/>54 Zero dollar with remittance data (for CCD and CTX Entries only)<br/>For Loan Debits: <br/>55 Loan Account Debit (Reversals Only)|	2	|2|	3|
|3|	RECEIVING DFI  IDENTIFICATION|	Mandatory|	First 8 digits of the receiving depository financial institution (RDFI) routing number|	8	|4|	11|
|4|	CHECK DIGIT	|Mandatory|	Last digit of the receiving depository financial institution (RDFI) routing number|	1|	12	|12|
|5|	RECEIVER’S ACCOUNT NUMBER AT RDFI|	Mandatory|	Alphanumeric Receiver’s account number at the RDFI to be credited or debited|	17|	13	|29|
|6|	AMOUNT|	Mandatory|	Dollar and Cents<br/> Amount in dollars and cents. Must be unsigned, without a decimal point, right justified and filled with leading zeros. E.g. $230.56 is completed as 0000023056|	10|	30|	39|
|7	|IDENTIFICATION NUMBER|	Optional|	Alphanumeric Additional identifying information for the Receiver or Originator.|	15|	40	|54|
|8|	NUMBER OF ADDENDA RECORDS|	Mandatory|	Numeric. |	4|	55|	58|
|9|	RECEIVING COMPANY NAME / ID NUMBER|	Mandatory|	Alphanumeric. Receiver name.|	16|	59	|74|
|10|	RESERVED|	N/A	|Fill with spaces.|	2|	75	|76|
|11	|DISCRETIONARY DATA	|Optional	|Alphanumeric<br/>This field is currently not used by GS Bank. Fill with spaces.|	2	|77|	78|
|12	|ADDENDA RECORD INDICATOR|	Mandatory	|Numeric. Enter one of the following values:<br/>0 — no addenda record for this Entry<br/>1 — one or more addenda records follow this Entry	|1|	79|	79|
|13|	TRACE NUMBER|	Mandatory|	Numeric.<br/>Unique identifier for each Entry within the batch. The first 8 digits must correspond to GS Bank’s routing number “02601507”, followed by a sequence number in ascending order within the batch.	|15|	80	|94|

## Entry Detail Record — type 6  - for IAT entries

|Field|	Field Name|	Requirement|	Contents / Type	|Length	|Start Position	|End Position|
|:----|:---|:----|:---|:---|:---|:----|
|1|	RECORD TYPE CODE	|Mandatory	|Always “6”	|1|	1|	1|
|2|	TRANSACTION CODE|	Mandatory|	Numeric. Enter one of the following values:<br/>For Credits:<br/>* 22 — Checking account credit<br/>* 32 — Savings account credit<br/>* 23 — Checking account prenotification (zero-dollar) <br/>* 33 — Savings account prenotification (zero-dollar)<br/> For Debits:<br/>* 27 — Checking account credit<br/>* 37 — Savings account credit<br/>* 28 — Checking account prenotification (zero-dollar)<br/>* 38 — Savings account prenotification (zero-dollar)<br/>* 39 — Savings account zero dollar with remittance data (for CCD,CTX and IAT entries only)|	2	|2|	3|
|3|	GATEWAY / RECEIVING DFI  IDENTIFICATION|	Mandatory|	First 8 digits of the routing number of the US receiving depository financial institution (RDFI) or the US Gateway Operator (in case of outbound IAT entries)|	8	|4|	11|
|4|	CHECK DIGIT	|Mandatory|	Last digit of the receiving depository financial institution (RDFI) routing number|	1|	12|	12|
|5	|NUMBER OF ADDENDA|	Mandatory|	Numeric. Total number of addenda records accompanying this entry. Note IAT entries must have a minimum of 7 mandatory addenda records and a maximum of 12|	4	|13	|16|
|6|	RESERVED|	N/A	|Leave blank|	13|	17|	29|
|7	|AMOUNT	|Mandatory	|$$$$$$$$——<br/> Amount in dollars and cents. Must be unsigned, without a decimal point, right justified and filled with leading zeros. E.g. $230.56 is completed as 0000023056	|10|	30|	39|
|8|	RECEIVER’S ACCOUNT NUMBER|	Mandatory|	Alphanumeric<br/> Receiver’s account number at the RDFI to be credited or debited. For outbound IAT entries, this should be the foreign Receiver’s account number|35|	40|	74|
|9	|RESERVED|	N/A	|Leave blank|	2	|75|	76|
|10	|GATEWAY OPERATOR OFAC SCREENING INDICATOR|	Optional|	Leave blank. For use by a Gateway Operator screen for OFAC compliance|	1	|77|	77|
|11	|SECONDARY OFAC SCREENING INDICATOR|	Optional|	Indicates the results of a Third-Party Service Provider screen for OFAC compliance, if applicable. This field must be space filled if no screening has been conducted.<br/>“0” — indicates that the Third-Party Service Provider has not found a potential blocked party, as identified by OFAC on its list of Specially Designated Nationals (“SDN list”). <br/>“1” — indicates the potential presence of a blocked party. |	1	|78|	78|
|12|	ADDENDA RECORD INDICATOR|	Mandatory|	Numeric. IAT entries must always have this as “1”|	1	|79	|79|
|13	|TRACE NUMBER|	Mandatory|	Numeric.<br/> Unique identifier for each Entry within the batch. The first 8 digits must correspond to GS Bank’s routing number “02601507”, followed by a sequence number in ascending order within the batch|	15|	80|	94|
 
*Entry Detail Record — Example*  
<mark>6</mark>32<mark>11112222</mark>3<mark>0008</mark>56789  &nbsp;&nbsp;&nbsp;     <mark>0000023062</mark>1234567890  &nbsp;&nbsp;&nbsp;       <mark>1026015070000001</mark>



## Addenda Record — type 7 -for all except IAT and TEL

Addenda record(s)may be optionally used to provide additional information relating to the Entry to the Receiver. The presence of an Addenda record(s) is indicated and validated against the Addenda record indicator in the Entry Detail record, and the Number of Addenda Records value (for CTX entries). IAT entries carry a special set of Addenda records that are described in the next section. Addenda records are not allowed on TEL entries.<br/>

|Field	|Field Name|	Requirement	|Contents / Type|	Length|	Start Position	|End Position|
|:-----|:----|:-----|:----|:----|:-----|:-----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “7”|	1	|1|	1|
|2|	ADDENDA TYPE CODE|	Mandatory	|Always “05”|	2	|2	|3|
|3|	PAYMENT RELATED INFORMATION	|Optional|	Alphanumeric<br/>Additional information related to payment for the receiver|	80	|4|	83|
|4|	ADDENDA SEQUENCE NUMBER	|Mandatory	|Numeric<br/>Sequence number starting with 0001|	4|	84|	87|
|5	|ENTRY DETAIL SEQUENCE NUMBER|	Mandatory|	Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|	7|	88|	94|


## Addenda Record — type 7 - IAT Entries

Every IAT Entry record must be followed by 7 mandatory Addenda records and up to 5 additional optional Addenda records — in all a maximum of 12 Addenda records. The Addenda record structure for IAT entries is summarized below:
* Addenda Type Codes “10” through “16” --> Mandatory, 7 IAT addenda records
* Addenda Type Code “17” --> Optional, up to a maximum of 2<sup>(*)</sup> IAT Remittance Information addenda records
* Addenda Type Code “18” --> Optional, up to a maximum of 5<sup>(*)</sup> IAT Foreign Correspondent Bank addenda records  

<br/><sup>(*)</sup> <font size="2"> The optional addenda records of type “17”and “18” cannot in total exceed 5 addenda records</font>

Record layout of each of the IAT Addenda Types is as provided below:


## 1st IAT Addenda Record


|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:----|:------|:-----|:-----|:-----|:----|:-----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “7”|	1	|1|	1|
|2|	ADDENDA TYPE CODE|	Mandatory|	Always “10”	|2|	2	|3|
|3|	TRANSACTION TYPE CODE	|Mandatory|	Alphanumeric<br/>Refer List of IAT Transaction Type Codes  |3	|4	|6|
|4|	FOREIGN PAYMENT AMOUNT|	Mandatory	|$$$$$$$$$$$$$$$$—<br/>* For Inbound IAT Entries, this field contains the amount for which the Entry was originated by the Foreign ODFI in the currency indicated by the Originating Currency Code (Company/Batch Header Record). <br/>* For Outbound IAT Entries, this field is populated based on the value in the Foreign Exchange Indicator as follows:<br/>&nbsp;&nbsp;&nbsp;&nbsp;- “FV” (fixed-to-variable), this field is zero-filled.<br/>&nbsp;&nbsp;&nbsp;&nbsp;- “VF” (variable-to-fixed) or “FF” (fixed-to-fixed), the amount for which the Entry is to be received by the foreign Receiver in the currency indicated by the ISO Destination Currency Code (Company/Batch Header Record).|	18|	7|	24|
|5	|FOREIGN TRACE NUMBER|	Optional|	Alphanumeric<br/>Applicable for inbound IAT entries. May include a trace number as assigned to the entry in the originating payments system.|	22|	25|	46|
|6|	RECEIVING COMPANY NAME / INDIVIDUAL NAME|	Mandatory|	Alphanumeric<br/>Name identifying the Receiver of the transaction.|35	|47	|81|
|7|	RESERVED|	N/A	|Leave blank|	6	|82	|87|
|8|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory	|Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|	7|88|	94|


## 2nd IAT Addenda Record
 

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position	|End Position|
|:----|:----|:----|:----|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “7”|	1	|1	|1|
|2|	ADDENDA TYPE CODE|	Mandatory|	Always “11”|	2	|2|	3|
|3|	ORIGINATOR NAME	|Mandatory|	Alphanumeric<br/>Name of the Originator of the transaction|35|	4|	38|
|4|	ORIGINATOR STREET ADDRESS|	Mandatory|	Alphanumeric<br/>Physical street address of the Originator of the transaction|	35	|39	|73|
|5|	RESERVED|	N/A|	Leave blank|	14|	74	|87|
|6|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory|	Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|	7	|88|	94|


## 3rd IAT Addenda Record
  

|Field|Field Name	|Requirement|	Contents / Type	|Length	|Start Position|	End Position|
|:----|:----|:-----|:----|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “7”|	1|	1|1|
|2|	ADDENDA TYPE CODE|	Mandatory|	Always “12”	|2|	2	|3|
|3|	ORIGINATOR CITY & STATE/PROVINCE|	Mandatory|	Alphanumeric<br/>City and, if applicable, the state or province of the Originator. An asterisk must be used as the delimiter between the data elements, and the backslash —\— or the tilde "~— must be used as the terminator following the last data element, e.g. SAN FRANCISCO*CA\	|35|	4|	38|
|4|	ORIGINATOR COUNTRY & POSTAL CODE|	Mandatory	|Alphanumeric<br/>ISO Country Code (2-char) followed by the postal code of the Originator. An asterisk must be used as the delimiter between the data elements, and the backslash —\— or the tilde —~— must be used as the terminator following the last data element, e.g. US*10282\	|35	|39|	73|
|5|	RESERVED|	N/A	|Leave blank|	14	|74|	87|
|6|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory	|Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record.|	7|	88|	94|


## 4th IAT Addenda Record
  

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position	|End Position|
|:-----|:-----|:----|:----|:----|:-----|:----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “7”|	1|	1	|1|
|2|	ADDENDA TYPE CODE|	Mandatory|	Always “13”<br/>The fields in this addenda record must identify the foreign financial institution initiating or funding the payment transaction (for inbound or outbound IAT entries) if any, or the U.S. ODFI (for outbound IAT entries).	|2|	2|	3|						
|3|	ORIGINATING DFI NAME|	Mandatory|	Alphanumeric.|	35|	4|	38|
|4|	ORIGINATING DFI IDENTIFICATION NUMBER QUALIFIER	|Mandatory|Enter a 2-digit code as below:<br/> * 01 — National Clearing System Number (e.g. US ABA)<br/> * 02 — SWIFT BIC<br/> * 03 — IBAN	2	39	40
|5	|ORIGINATING DFI IDENTIFICATION|	Mandatory|	Alphanumeric. <br/>Identifier for the financial institution as per the numbering scheme indicated above.|	34	|41	|74|
|6|	ORIGINATING DFI BRANCH COUNTRY CODE	|Mandatory|	Alphanumeric.<br/>ISO 2-char Country Code of the institution identified in this record.	|3|	75|	77|
|7|	RESERVED|	N/A	|Leave blank|	10	|78|	87|
|8|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory|	Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|	7	|88	|94|


## 5th IAT Addenda Record 

|Field|	Field Name|	Requirement	|Contents / Type|	Length	|Start Position	|End Position|
|:----|:-----|:----|:-----|:----|:-----|:----|
|1	|RECORD TYPE CODE|	Mandatory|	Always “7”|	1	|1|	1|
|2	|ADDENDA TYPE CODE	|Mandatory	|Always “14”<br/>The fields in this addenda record identify the Receiving DFI at which the Receiver maintains their account.		|2	|2	|3|					
|3	|RECEIVING DFI NAME|	Mandatory	|Alphanumeric.|	35	|4|	38|
|4|	RECEIVING DFI IDENTIFICATION NUMBER QUALIFIER|	Mandatory|	Enter a 2-digit code as below: <br/> * 01 — National Clearing System Number (e.g. US ABA)<br/> * 02 — SWIFT BIC<br/> * 03 — IBAN|	2	|39|	40|
|5|	RECEIVING DFI IDENTIFICATION|	Mandatory|	Alphanumeric<br/>Identifier for the financial institution as per the numbering scheme indicated above.|	34|	41	|74|
|5|	RECEIVING DFI BRANCH COUNTRY CODE|	Mandatory	|Alphanumeric<br/>ISO 2-char Country Code of the institution identified in this record.	|3	|75||77|
|6|	RESERVED|	N/A|	Leave blank|	10|	78|	87|
|7|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory	|Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|7	|88|	94|


## 6th IAT Addenda Record
 

|Field|	Field Name|	Requirement|	Contents / Type	|Length	|Start Position	|End Position|
|:-----|:----|:----|:----|:----|:----|:-----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “7”|	1|	1|	1|
|2	|ADDENDA TYPE CODE	|Mandatory|	Always “15”|	2	|2|	3|
|3|	RECEIVER IDENTIFICATION NUMBER|	Optional|	Alphanumeric<br/>May be used by the Originator to insert its own number for tracing purposes.	|15|	4	|18|
|4|	RECEIVER STREET ADDRESS|	Mandatory|	Alphanumeric<br/>Physical street address of the Receiver of the transaction.|	35|	19|	53|
|5|	RESERVED|	N/A	|Leave blank|	34	|54|	87|
|6|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory|	Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record.|	7|	88|	94|

## 7th IAT Addenda Record 
  

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:----|:----|:----|:----|:----|:----|:---|
|1|	RECORD TYPE CODE|	Mandatory|	Always “7”|	1	|1|	1|
|2|	ADDENDA TYPE CODE|	Mandatory|	Always “16”|	2|	2	|3|
|3|	RECEIVER CITY & STATE/PROVINCE|	Mandatory	|Alphanumeric<br/>City and, if applicable, the state or province of the Receiver. An asterisk must be used as the delimiter between the data elements, and the backslash —\— or the tilde —~— must be used as the terminator following the last data element, e.g. SAN FRANCISCO*CA\|	35|	4	|38|
|4	|RECEIVER COUNTRY & POSTAL CODE	|Mandatory|	Alphanumeric<br/>ISO Country Code (2-char) followed by the postal code of the Receiver. An asterisk must be used as the delimiter between the data elements, and the backslash —\— or the tilde —~— must be used as the terminator following the last data element, e.g. US*10282\	|35|	39|	73|
|5|	RESERVED|	N/A	|Leave blank|	14|	74|	87|
|6|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory	|Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|	7|	88|	94|


## Remittance Information — IAT Addenda Record  <a name="remittance"></a>


This Addenda Type accommodates the transmission of optional remittance information. A maximum of 2 optional remittance addenda records can accompany an IAT entry, within which a maximum of 160 characters (80 characters per addenda record) of remittance information can be included. These addenda records may also carry information of the ultimate payer or ultimate beneficiary for IAT payments that involve a further “for the credit to /by order of” parties.

|Field	|Field Name|	Requirement	|Contents / Type	|Length	|Start Position|	End Position|
|:---|:---|:----|:----|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “7”|	1|	1	|1|
|2|	ADDENDA TYPE CODE|	Mandatory	|Always “17”|	2|	2|	3|
|3|	PAYMENT RELATED INFORMATION	|Optional	|Alphanumeric<br/>This field may contain additional information related to payment for the receiver. It may also carry information identifying the ultimate payer/beneficiary, or in the case of IAT entries that contain ARC, BOC, RCK, POP, MTE, POS or SHR in the Transaction Type code, the additional information as required by those entries.<br/>The identification of the ultimate foreign beneficiary (of the debit) or ultimate foreign payer (of the credit) takes priority over the inclusion of other payment related information.<br/>An asterisk must be used as the delimiter between the data elements, and the backslash —\— or the tilde —~— must be used as the terminator following the last data element,<br/>e.g. JOHN SMITH*10 CHERRY LANE*LONDON*105SW2*GB\|	80|	4	|83|
|4|	ADDENDA SEQUENCE NUMBER|	Mandatory	|Numeric<br/>Sequence number starting with 0001	|4|	84|	87|
|5	|ENTRY DETAIL SEQUENCE NUMBER|	Mandatory	|Numeric<br/>Last 7 digits of the Trace Number of the related Entry Detail record|	7	|88|	94|


## Foreign Correspondent Bank — IAT Addenda Record <a name="foreigncorrespondent"></a>

A separate addenda record must be added to the payment for each Foreign Correspondent Bank that is involved with the transmission or exchange of an IAT entry, providing parties to the transaction with additional information needed to identify and react to unlawful transactions. 
A maximum of five Foreign Correspondent Bank addenda records may accompany an IAT entry.

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:---|:---|:---|:---|:---|:---|:---|
|1|	RECORD TYPE CODE	|Mandatory	|Always “7”|	1	|1|	1|
|2|	ADDENDA TYPE CODE|	Mandatory	|Always “18”|	2|	2	|3|
|3|	FOREIGN CORR. BANK NAME	|Mandatory|	Alphanumeric.	|35	|4	|38|
|4|	FOREIGN CORR. BANK IDENTIFICATION NUMBER QUALIFIER|	Mandatory	|Enter a 2-digit code as below —<br/> * 01 — National Clearing System Number (e.g. US ABA)<br/> * 02 — SWIFT BIC<br/>* 03 — IBAN	|2|	39|	40|
|5|	FOREIGN CORR. BANK IDENTIFICATION|	Mandatory|	Alphanumeric.<br/>Identifier for the financial institution as per the numbering scheme indicated above.|	34|	41|	74|
|6|	FOREIGN CORR. BANK BRANCH COUNTRY CODE|	Mandatory	|Alphanumeric.<br/>ISO 2-char Country Code of the institution identified in this record.|	3	|75|	77|
|7|	RESERVED|	N/A	|Leave blank|	10|	78|	87|
|8|	ENTRY DETAIL SEQUENCE NUMBER|	Mandatory	|Numeric<br/> Last 7 digits of the Trace Number of the related Entry Detail record.|	7	|88|	94|

## List of Transaction Type Codes (IAT Entries)  <a name="transactiontypecode"></a>
The Transaction Type Code is a required, three-character field in the 1st IAT Addenda record. This field contains a code as per the following lists, used to identify —<br/>
* In the case of Outbound IAT entries, a Reason for Payment from one of the codes in the below list.
* In the case of Inbound IAT entries, 
>>* a secondary SEC code for certain inbound IAT entries to indicate the use of an underlying ACH application by an entity outside the territorial jurisdiction of the United States, or where that is not required
>>* a Reason for Payment. The requirement to include a secondary SEC Code takes priority over the reason for the payment.

**Reasons for Payment**
>>>ANN — Annuity<br/>BUS — Business/Commercial<br/>DEP — Deposit<br/>LOA — Loan<br/>MIS — Miscellaneous<br/>MOR —Mortgage<br/>PEN — Pension<br/>REM — Remittance<br/>RLS — Rent/Lease<br/>SAL — Salary/Payroll<br/>TAX — Tax<br/>

**Secondary SEC Codes**<br/>
For inbound IAT entries, the Transaction Type Code field is used to identify ACH transactions that were originated using other ACH applications by parties outside the territorial jurisdiction of the United States. Only the following SEC Codes are defined for use as secondary SEC Codes in the IAT.<br/>
* ARC — Accounts Receivable Entry
* BOC — Back Office Conversion Entry
* MTE — Machine Transfer Entry
* POP — Point of Purchase Entry
* POS — Point of Sale Entry
* RCK — Re-presented Check Entry
* SHR — Shared Network Transaction
* TEL — Telephone-Initiated Entry
* WEB — Internet-Initiated Entry

Some of these secondary SEC codes require the provision of additional information. In such cases, an asterisk should be used as the delimiter between data elements, and the backslash (\) or tilde (~) will be the terminator between the data segments.<br/>
* ARC, BOC, or RCK entries must provide the check serial number
>>CHECK SERIAL NUMBER\ or ~ 
>>Example: 3349809002\ or ~ 
* POP entries must provide the check serial number, terminal city, and terminal state/ foreign country
>>CHECK SERIAL NUMBER (MAXIMUM OF 9 CHARACTERS)*TERMINAL CITY (MAXIMUM OF 4 CHARACTERS)*TERMINAL 
>>>>STATE/FOREIGN COUNTRY (2 CHARACTERS)\ or ~ 
>>Example: 123456789*PARI*FR\ or ~ 
* MTE, POS, or SHR entries must provide the terminal identification code, terminal location, terminal city, and terminal state/foreign country
>>TERMINAL IDENTIFICATION CODE (MAXIMUM OF 6 CHARACTERS)*TERMINAL LOCATION (MAXIMUM OF 27 
>>>>CHARACTERS)*TERMINAL CITY (MAXIMUM OF 15 CHARACTERS)*TERMINAL STATE/FOREIGN COUNTRY (2 
>>>>CHARACTERS)\ or ~ 
>>Examples: 	201209*321 EAST MAIN STREET*ANYTOWN*GA\ or ~ 
>>>>>>364402*12TH & TOLL STREET*LONDON*UK\ or ~


## Company / Batch Control Record — type 8
The Company/Batch Control Record contains the counts, hash totals, and total dollar controls for the preceding Entries within the batch. All Entry Detail Records are hashed. Both Entry Detail Records and Addenda Records are included in the Entry/addenda counts; Batch Header and Batch Control Records are not included.

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:---|:---|:---|:----|:---|:---|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “8”|	1	|1|	1|
|2|	SERVICE CLASS CODE|	Mandatory	|Numeric.<br/>Should be the same as the Service Class Code of the associated Company / Batch Header record.|	3|	2|	4|
|3|	ENTRY/ ADDENDA COUNT|	Mandatory	|Numeric.<br/>Total number of entry and addenda records in the batch.	|6|	5	|10|
|4|	ENTRY HASH	|Mandatory|	Numeric.<br/> Sum of the 8-digit RDFI routing numbers in the Entry Detail records in the batch. Use the right-most 10 digits if the sum exceeds 10 digits, and fill with leading 0—s if less than 10 digits.|	10|	11|	20|
|5|	TOTAL DEBIT ENTRY DOLLAR AMOUNT	|Mandatory|	Dollar and Cent<br/>Sum of Entry Detail debit totals within the batch.|	12|	21	|32|
|6|	TOTAL CREDIT ENTRY DOLLAR AMOUNT|	Mandatory	|dollar and Cent<br/>Sum of Entry Detail credit totals within the batch.	|12|	33|	44|
|7|	COMPANY IDENTIFICATION	|Mandatory|	Alphanumeric. Should be the same as the Company ID of the associated Company / Batch Header record.|	10|	45|	54|
|8|	MESSAGE AUTHENTICATION CODE|	N/A|	Alphanumeric.<br/>Not used. Fill with spaces.|	19|	55	|73|
|9|	RESERVED|	N/A	|Fill with spaces	|6|	74|	79|
|10|	ORIGINATING DFI IDENTIFICATION	|Mandatory|	Always “02601507” (first 8 digits of GS Bank’s routing number)|	8	|80|	87|
|11	|BATCH NUMBER	|Mandatory	|Numeric. Should be the same as the Batch Number of the associated Company / Batch Header record.|	7|	88|	94|

Company / Batch Control Record — Example 
<mark>8</mark>220<mark>000003</mark>0033336666<mark>000000000000</mark>000000300000<mark>1234567890</mark>&nbsp;<mark>&nbsp;&nbsp;</mark>&nbsp;&nbsp;02601507<mark>0000001</mark>

## File Control Record — type 9
The File Control Record contains control totals for the entries, batches and blocks in the file.

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:----|:----|:---|:---|:---|:---|:----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “9” |	1	|1|	1|
|2|	BATCH COUNT	|Mandatory|	Numeric. Number of batches in the file.|	6|	2	|7|
|3|	BLOCK COUNT	|Mandatory|	Numeric. Total number of blocks in the file. Block = 10 records (including all Header and Control records and Blocking control records).|	6	|8|	13|
|4|	ENTRY/ADDENDA COUNT|	Mandatory	|Numeric. Total number of Entry Detail and Addenda records in the file.	|8|	14|	21|
|5|	ENTRY HASH|	Mandatory|Numeric. Sum of all Entry Hash fields in each Company/Batch Control record contained within the file. Use the right-most 10 digits if the sum exceeds 10 digits, and fill with leading 0—s if less than 10 digits.	|10|	22|	31|
|6|	TOTAL DEBIT ENTRY DOLLAR AMOUNT IN FILE	|Mandatory|	Dollar and Cents<br/>Sum of Entry Detail debit totals within the file.	|12|	32|	43|
|7|	TOTAL CREDIT ENTRY DOLLAR AMOUNT IN FILE|	Mandatory	|Dollar and Cents <br/>Sum of Entry Detail credit totals within the file.	|12|	44|	55|
|8	|RESERVED|	N/A	|Always filled with spaces|	39|	56|	94|

File Control Record — Example   
<mark>9</mark>000003<mark>000002</mark>00000010<mark>0077785554</mark>000000000000<mark>000000700000</mark>  
                           





================================================================================
FILE: transaction-banking/ach-iat.mdx
================================================================================

---
title: ACH IAT
keywords:
  - txb
  - transaction banking
---

## List of Transaction Type Codes (IAT Entries)  <a name="transactiontypecode"></a>
The Transaction Type Code is a required, three-character field in the 1st IAT Addenda record. This field contains a code as per the following lists, used to identify —<br/>
* In the case of Outbound IAT entries, a Reason for Payment from one of the codes in the below list.
* In the case of Inbound IAT entries, 
>>* a secondary SEC code for certain inbound IAT entries to indicate the use of an underlying ACH application by an entity outside the territorial jurisdiction of the United States, or where that is not required
>>* a Reason for Payment. The requirement to include a secondary SEC Code takes priority over the reason for the payment.

**Reasons for Payment**
>>>ANN — Annuity<br/>BUS — Business/Commercial<br/>DEP — Deposit<br/>LOA — Loan<br/>MIS — Miscellaneous<br/>MOR —Mortgage<br/>PEN — Pension<br/>REM — Remittance<br/>RLS — Rent/Lease<br/>SAL — Salary/Payroll<br/>TAX — Tax<br/>

**Secondary SEC Codes**<br/>
For inbound IAT entries, the Transaction Type Code field is used to identify ACH transactions that were originated using other ACH applications by parties outside the territorial jurisdiction of the United States. Only the following SEC Codes are defined for use as secondary SEC Codes in the IAT.<br/>
* ARC — Accounts Receivable Entry
* BOC — Back Office Conversion Entry
* MTE — Machine Transfer Entry
* POP — Point of Purchase Entry
* POS — Point of Sale Entry
* RCK — Re-presented Check Entry
* SHR — Shared Network Transaction
* TEL — Telephone-Initiated Entry
* WEB — Internet-Initiated Entry

Some of these secondary SEC codes require the provision of additional information. In such cases, an asterisk should be used as the delimiter between data elements, and the backslash (\) or tilde (~) will be the terminator between the data segments.<br/>
* ARC, BOC, or RCK entries must provide the check serial number
>>CHECK SERIAL NUMBER\ or ~ 
>>Example: 3349809002\ or ~ 
* POP entries must provide the check serial number, terminal city, and terminal state/ foreign country
>>CHECK SERIAL NUMBER (MAXIMUM OF 9 CHARACTERS)*TERMINAL CITY (MAXIMUM OF 4 CHARACTERS)*TERMINAL 
>>>>STATE/FOREIGN COUNTRY (2 CHARACTERS)\ or ~ 
>>Example: 123456789*PARI*FR\ or ~ 
* MTE, POS, or SHR entries must provide the terminal identification code, terminal location, terminal city, and terminal state/foreign country
>>TERMINAL IDENTIFICATION CODE (MAXIMUM OF 6 CHARACTERS)*TERMINAL LOCATION (MAXIMUM OF 27 
>>>>CHARACTERS)*TERMINAL CITY (MAXIMUM OF 15 CHARACTERS)*TERMINAL STATE/FOREIGN COUNTRY (2 
>>>>CHARACTERS)\ or ~ 
>>Examples: 	201209*321 EAST MAIN STREET*ANYTOWN*GA\ or ~ 
>>>>>>364402*12TH & TOLL STREET*LONDON*UK\ or ~










================================================================================
FILE: transaction-banking/ach-inbound.mdx
================================================================================

---
title: ACH Returns & NOCs File (GS-adapted NACHA format)
keywords:
  - txb
  - transaction banking
---

The ACH Inbound Returns & NOCs File contains information of inbound and outbound Return items and Notification of Change (NOC) entries for ACH transactions originated by clients through GS Bank USA.

### File Format Overview
The ACH Inbound Returns & NOC File follows a similar NACHA format (GS-adapted) as the ACH Transactions Origination File through which the transactions were originated. The file will contain Blocking File Control records as necessary, in order to ensure that total record count in the file is a multiple of 10. For example, if the file contains 26 records, there will be 4 Blocking File Control records to make the total count 30. Blocking Control records are filled with all 9—s.

## Record Structure
### File Header Record — type 1
The File Header Record follows the standard File Header Record format.

|Field|	Field Name|	Requirement	|Contents / Type	|Length|	Start Position|	End Position|
|:---|:---|:---|:---|:---|:---|:---|
|1|	RECORD TYPE CODE|	Mandatory	|Always “1”|	1|	1|	1|
|2|	PRIORITY CODE	|Mandatory	|Always “01”|	2	|2|	3|
|3|	IMMEDIATE DESTINATION	|Mandatory|	GS Bank routing number<br/> Always “b026015079”  (“b”= space)|	10	|4|	13|
|4|	IMMEDIATE ORIGIN|	Mandatory	|File ID for this Return/NOC file, provided by GS Bank	|10|	14|	23|
|5|	FILE CREATION DATE	|Mandatory|	Date in “YYMMDD”|	6	|24|	29|
|6|	FILE CREATION TIME|	Mandatory	|Time in “HHMM” |	4	|30|	33|
|7|	FILE ID MODIFIER|	Mandatory|	Upper case A-Z Numeric 0-9<br/>Will always be “0” representing the single Returns/NOC file sent at the end of each day.|	1|	34|	34|
|8	|RECORD SIZE|	Mandatory	|Always “094”|	3	|35|	37|
|9	|BLOCKING FACTOR|	Mandatory	|Always “10”	|2	|38	|39|
|10|	FORMAT CODE	|Mandatory|	Always “1”|	1	|40|	40|
|11|	IMMEDIATE DESTINATION NAME|	Mandatory	|Alphanumeric. Receiving client organization name.|	23|	41|	63|
|12|	IMMEDIATE ORIGIN NAME	|Mandatory	|Always “GS BANK USA”|	23|	64|	86|
|13|	REFERENCE CODE	|Optional	|Filled with blank or spaces|	8	|87|	94|

### Company / Batch Header Record — type 5 

The Company / Batch Header record for a Return or NOC entry largely retains field values corresponding to the original ACH transaction. These are shaded in grey below. The remaining fields are populated with codes or values pertinent to Return or NOC entries.

|Field|	Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:----|:----|:----|:---|:----|:---|:----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “5”|	1|	1	|1|
|2|	SERVICE CLASS CODE|	Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	3	|2|	4|
|3|	COMPANY NAME	|Mandatory|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates|	16|	5	|20|
|4|	COMPANY DISCRETIONARY DATA|	Optional|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates|	20	|21|	40|
|5|	COMPANY IDENTIFICATION|	Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates	|10	|41|	50|
|6|	STANDARD ENTRY CLASS CODE<sup>3</sup> |	Mandatory	|For NOCs, will contain the value “COR”. For Returns, will contain the SEC code of the original entry. |	3|	51|	53|
|7|	COMPANY ENTRY DESCRIPTION	|Mandatory|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|10|	54|	63|
|8|	COMPANY DESCRIPTIVE DATE|	Optional|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	6	|64|	69|
|9|	EFFECTIVE ENTRY DATE|	Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.	|6|	70|	75|
|10|	SETTLEMENT DATE (JULIAN)|	Mandatory|	For Returns, date the return was posted to client’s account. For NOCs, will be “000” | 	3	|76	|78|
|11|	ORIGINATOR STATUS CODE|	Mandatory|	Always “1”|	1	|79	|79|
|12|	ORIGINATING DFI IDENTIFICATION|	Mandatory	|Always —02601507<br/>(first 8 digits of GS Bank’s routing number)|	8	|80	|87|
|13|	BATCH NUMBER|	Mandatory	|Numeric<br/>Start with “0000001” and increment by 1 for each subsequent batch in the file.|7	|88|	94|

<sup>3</sup><font size="1">See section on Standard Entry Class codes and their descriptions for a further description of supported codes</font>

### Entry Detail Record — type 6 — for CCD, PPD, IAT, WEB and TEL entries
The Entry Detail record for a Return or NOC entry largely retains field values corresponding to the original ACH transaction. These are shaded in grey below. The remaining fields are populated with codes or values pertinent to Return or NOC entries. Record structure for CTX entries is outlined in the next section

|Field	|Field Name|	Requirement|	Contents / Type	|Length	|Start Position	|End Position|
|:----|:---|:----|:---|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “6”|	1	|1|	1|
|2|	TRANSACTION CODE|	Mandatory|	Numeric. Contains one of the following values, that indicates a Return or NOC<br/>* 21 — for original transaction codes 22, 23<br/>* 26 — for original transaction codes 27, 28<br/>* 31 — for original transaction codes 32, 33<br/>* 36 — for original transaction codes 37, 38|	2	|2|	3|
|3|	RECEIVING DFI  IDENTIFICATION	|Mandatory|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	8	|4|	11|
|4|	CHECK DIGIT	| Mandatory | These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates|1	|12	|12|
|5|	RECEIVER’S ACCOUNT NUMBER AT RDFI	|Mandatory|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|		17|	13|	29|
|6|	AMOUNT|Mandatory|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|		10|	30|	39|
|7|	(INDIVIDUAL) IDENTIFICATION NUMBER|	Optional|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|		15|	40|	54|
|8|	INDIVIDUAL / RECEIVING COMPANY NAME|	Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	22|	55|	76|
|9|	DISCRETIONARY DATA / PAYMENT TYPE CODE	|Conditional|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	2|	77|	78|
|10	|ADDENDA RECORD INDICATOR	|Mandatory	|Always 1, to indicate that an addenda record follows this entry|	1	|79|	79|
|11	|TRACE NUMBER	|Mandatory|	Numeric<br/>Unique identifier for each Entry within the batch. The first 8 digits correspond to GS Bank’s routing number “02601507”, followed by a sequence number in ascending order within the batch.|	15	|80|	94|

### Entry Detail Record — type 6 — for CTX entries
|Field|	Field Name|	Requirement|	Contents / Type|	Length|	Start Position|	End Position|
|:----|:---|:----|:----|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory|	Always “6”|	1	|1|	1|
|2|	TRANSACTION CODE|	Mandatory	|Numeric. Contains one of the following values, that indicates a Return or NOC<br/>* 21 — for original transaction codes 22, 23<br/>* 26 — for original transaction codes 27, 28<br/>* 31 — for original transaction codes 32, 33<br/>* 36 — for original transaction codes 37, 38|	2	|2|	3|
|3|	RECEIVING DFI  IDENTIFICATION|	Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	8	|4|	11|
|4|	CHECK DIGIT|	Mandatory|	These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	1	|12	|12|
|5|	RECEIVER’S ACCOUNT NUMBER AT RDFI	|Mandatory|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|		17|	13	|29|
|6|	AMOUNT|	Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	10|	30|	39|
|7|	IDENTIFICATION NUMBER	|Optional	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	15|	40	|54|
|8|	NUMBER OF ADDENDA RECORDS|	Mandatory	|Always “0001”|	4	|55|	58|
|9	|RECEIVING COMPANY NAME / ID NUMBER	|Mandatory	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	16	|59	|74|
|10	|RESERVED|	N/A|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|		2	|75|	76|
|11|	DISCRETIONARY DATA|	Optional	|These fields are populated with the corresponding values from the original ACH entry to which the return / NOC relates.|	2	|77	|78|
|12|	ADDENDA RECORD INDICATOR|	Mandatory	|Always 1, to indicate that an addenda record follows this entry|	1	|79|	79|
|13	|TRACE NUMBER	|Mandatory|	Numeric. Unique identifier for each Entry within the batch. The first 8 digits correspond to GS Bank’s routing number “02601507”, followed by a sequence number in ascending order within the batch.|	15|	80	|94|

### Addenda Record — type 7 
The Addenda record for a Return or NOC entry provides the Return / Change Codes, together with additional information as applicable. For IAT Returns, the 7 mandatory addenda records are not included in this pseudo-NACHA format report.

|Field	|Field Name|	Requirement	|Contents / Type	|Length	|Start Position	|End Position|
|:----|:----|:----|:----|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “7”|	1|	1	|1|
|2|	ADDENDA TYPE CODE|	Mandatory	|For NOCs: always “98”<br/>For Returns: always “99”|	2	|2|	3|
|3|	RETURN / CHANGE CODE|	Mandatory|	Contains a 3-character code.<br/> For Returns, see List of Return Codes & reasons<br/>For NOCs, see List of Change Codes |	3	|4|	6|
|4|	ORIGINAL ENTRY TRACE NUMBER	|Mandatory	|Trace number from positions 80-94 of the original Entry Detail Record or Corporate Entry Detail Record.|	15	|7|	21|
|5|	DATE OF DEATH	|Conditional|	Applicable only for Return Codes R14 or R15. Entered as YYMMDD. |	6	|22|	27|
|6|	ORIGINAL RDFI IDENTIFICATION	|Mandatory	|First 8 digits of RDFI routing number from positions 4-11 of the original ACH Entry Detail record.	|8|	28|	35|
|7|	ADDENDA INFORMATION	|Conditional|	For NOCs, only the first 29 positions of this field are used to indicate the Corrected Data. The Corrected Data elements follow a format as specified in the List of Change Codes.<br/>For non-IAT Returns, this field contains additional description for return codes R11 and R17.<br/>For IAT Returns, the first 10 positions of this field contains the Original Forward Entry Payment Amount ($$$$$$$$cc). The remainder of this field contains additional description for return codes R11 and R17.	|44	|36	|79|
|8|	TRACE NUMBER	|Mandatory|	Same Trace Number as corresponding Entry Detail record for the Return/NOC.|	15	|80|	94|

### Company / Batch Control Record — type 8
The Company/Batch Control Record for Return / NOC files follows the standard NACHA format, as applicable for Origination files. It is detailed below for sake of completeness below. 
All Entry Detail Records are hashed. Both Entry Detail Records and Addenda Records are included in the Entry/addenda counts; Batch Header and Batch Control Records are not included.

|Field	|Field Name|	Requirement|	Contents / Type	|Length	|Start Position|	End Position|
|:-----|:----|:----|:-----|:----|:----|:----|
|1|	RECORD TYPE CODE|	Mandatory	|Always “8”	|1|	1	|1|
|2|	SERVICE CLASS CODE	|Mandatory|	Numeric. Should be the same as the Service Class Code of the associated Company / Batch Header record.|	3	|2|	4|
|3|	ENTRY/ ADDENDA COUNT|	Mandatory	|Numeric. Total number of entry and addenda records in the batch.|	6|5	|10|
|4	|ENTRY HASH	|Mandatory|	Numeric<br/>Sum of the 8-digit RDFI routing numbers in the Entry Detail records in the batch. Use the right-most 10 digits if the sum exceeds 10 digits, and fill with leading 0—s if less than 10 digits.|	10|	11	|20|
|5|	TOTAL DEBIT ENTRY DOLLAR AMOUNT	|Mandatory	|Dollar and Cent<br/>Sum of Entry Detail debit totals within the batch.|	12|	21|	32|
|6|	TOTAL CREDIT ENTRY DOLLAR AMOUNT	|Mandatory|Dollar and Cent<br/>Sum of Entry Detail credit totals within the batch.|	12|	33|	44|
|7|	COMPANY IDENTIFICATION	|Mandatory|	Alphanumeric. Should be the same as the Company ID of the associated Company / Batch Header record.	|10	|45|	54|
|8|	MESSAGE AUTHENTICATION CODE|	N/A|	Alphanumeric.<br/> Not used. Fill with spaces.|	19	|55	|73|
|9|	RESERVED	|N/A|	Fill with spaces|	6	|74	|79\
|10|	ORIGINATING DFI IDENTIFICATION	|Mandatory|	Always “02601507” (first 8 digits of GS Bank’s routing number)|	8	|80|	87|
|11|	BATCH NUMBER|	Mandatory	|Numeric. Should be the same as the Batch Number of the associated Company / Batch Header record.|	7	|88|	94|

### File Control Record — type 9
The File Control Record for Return / NOC files follows the standard NACHA format, as applicable for Origination files. It is detailed below for sake of completeness below. 

|Field	|Field Name|	Requirement	|Contents / Type|	Length|	Start Position|	End Position|
|:----|:----|:----|:-----|:----|:----|:----|
|1	|RECORD TYPE CODE	|Mandatory|	Always “9” |	1	|1|	1|
|2	|BATCH COUNT	|Mandatory	|Numeric. Number of batches in the file.|	6	|2	|7|
|3|	BLOCK COUNT	|Mandatory|	Numeric. Total number of blocks in the file. Block = 10 records (including all Header and Control records and Blocking control records).|	6|	8|	13|
|4|	ENTRY/ADDENDA COUNT	|Mandatory|	Numeric. Total number of Entry Detail and Addenda records in the file.|	8	|14|	21|
|5	|ENTRY HASH	|Mandatory	|Numeric. Sum of all Entry Hash fields in each Company/Batch Control record contained within the file. Use the right-most 10 digits if the sum exceeds 10 digits, and fill with leading 0—s if less than 10 digits.	|10	|22|	31|
|6	|TOTAL DEBIT ENTRY DOLLAR AMOUNT IN FILE|	Mandatory	|Dollar and Cent<br/>Sum of Entry Detail debit totals within the file.	|12	|32	|43|
|7|	TOTAL CREDIT ENTRY DOLLAR AMOUNT IN FILE|	Mandatory	|Dollar and Cent<br/>Sum of Entry Detail credit totals within the file.|	12|	44|	55|
|8	|RESERVED|	N/A|	Always filled with spaces	|39	|56	|94|



================================================================================
FILE: transaction-banking/ach-overview.mdx
================================================================================

---
title: ACH Transactions Origination File (GS-adapted NACHA format)
keywords:
  - txb
  - transaction banking
---

Goldman Sachs TxB follows the NACHA Operating Rules and Guidelines for purposes of a TxB client's formatting and originating ACH entries.  This Guide furnishes a client with the settings and values specific to originating an ACH entry with TxB (a GS-adapted NACHA format).  For example, TxB treats each NACHA Required field as a Mandatory field.  Separately, although this Guide covers IAT, TEL and WEB entries, those ACH entry types require prior TxB approval and implementation; please contact your TxB Client Service representative to enquire.

## File Format Overview

### File Structure

An ACH file contains multiple records, each with a fixed length of 94 characters and starting on a new line. The file follows the overall structure outlined below:   

<Grid layoutOption="fourColumn">

<ImageBlock image={'/services/transaction-banking/ACH_NACHA_Diagram.jpg'} width="852" height= "550" center />

</Grid>

### Permitted Character Set & Other Field Population Rules:

#### Supported characters for US FedACH

* Alphabets [A-Za-z]
* Numerals [0-9]
* Space
* Special characters . , - ( ) / + ' = : ? @ _ # Cr Lf Space \{ ! " % & * ; < > | ~ ` $ ^ \} [ \\ ]
* Each field carries a fixed length and position as specified.
* Alphanumeric fields are left-justified and “space” filled. Numeric fields are right-justified and “0” filled


================================================================================
FILE: transaction-banking/ach-return-codes.mdx
================================================================================

---
title: ACH Return Codes
keywords:
  - txb
  - transaction banking
---

|Code|Description|Explanation|Initiated By|
|----|-------|----------|-------|
|R01|Insufficient Funds|The available and/or cash reserve balance is not sufficient to cover the dollar value of the debit Entry.|RDFI|
|R02|Account Closed|A previously active account has been closed by action of the customer or the RDFI.|RDFI|
|R03|No Account/ Unable to Locate Account|The account number structure is valid, and it passes the check digit validation, but the account number does not correspond to the individual identified in the Entry, or the account number designated is not an existing account.|RDFI|
|R04|Invalid Account Number Structure|The account number structure is not valid.|RDFI|
|R05|Unauthorized Debit to Consumer Account Using Corporate SEC Code|CCD or CTX debit Entry was Transmitted to a Consumer Account of the Receiver and was not authorized by the Receiver.|RDFI|
|R06|Returned per ODFI’s Request|The ODFI has requested that the RDFI return an Erroneous Entry, or a credit Entry originated without the authorization of the Originator.|RDFI|
|R07|Authorization Revoked by Customer|The RDFI’s customer (the Receiver) revoked the authorization previously provided to the Originator for this debit Entry.|RDFI|
|R08|Payment Stopped|The Receiver has placed a stop payment order on this debit Entry.|RDFI|
|R09|Uncollected Funds|A sufficient ledger balance exists to satisfy the dollar value of the transaction, but the available balance is below the dollar value of the debit Entry.|RDFI|
|R10|Customer Advises Unauthorized, Improper, Ineligible, or Part of an Incomplete Transaction Customer Advises Originator is Not Known to Receiver and/or Originator is Not Authorized by Receiver to Debit Receiver’s Account|The RDFI has been notified by the Receiver that the Entry is unauthorized, improper, ineligible, or part of an Incomplete Transaction.The RDFI has been notified by the Receiver that the Receiver does not know the identity of the Originator; has no relationship with the Originator; or has not authorized the Originator to debit his account.For ARC and BOC entries, the RDFI has been notified by the Receiver that the signature on the source document is not authentic, valid, or authorized.For POP Entries, the RDFI has been notified by the Receiver that the signature on the written authorization is not authentic, valid, or authorized.|RDFI|
|R11|Check Truncation Entry Return Customer Advises Entry Not in Accordance with the Terms of the Authorization|This Return Reason Code is used when returning a Check truncation Entry.The RDFI has been notified by the Receiver that the Originator and Receiver have a relationship and an authorization to debit exists, but there is an error or defect in the payment such that the entry does not conform to the terms of the authorization (for example, the entry is for an amount different than authorized; the entry was initiated for settlement earlier than authorized; the entry is part of an Incomplete Transaction; the debit entry was improperly reinitiated; for ARC, BOC, or POP entries: ineligible source document, notice was not provided; amount of the entry was not accurately obtained from the source document.||RDFI|
|R12|Account Sold to Another DFI|A financial institution received an Entry to an account that was sold to another financial institution.|RDFI|
|R13|Invalid ACH Routing Number|Entry contains a Receiving DFI Identification or Gateway Identification that is not a valid ACH routing number.|ACH Operator|
|R14|Representative Payee Deceased or Unable to Continue in That Capacity|The representative payee is either deceased or unable to continue in that capacity. The beneficiary is not deceased.|RDFI|
|R15|Beneficiary or Account Holder (Other Than a Representative Payee) Deceased|(1) The beneficiary is deceased; or (2) the account holder is deceased.|RDFI|
|R16|Account Frozen/Entry Returned Per OFAC Instruction|(1) Access to the account is restricted due to specific action taken by the RDFI or by legal action; or (2) OFAC has instructed the RDFI or Gateway to return the Entry.|RDFI or Gateway|
|R17|File Record Edit Criteria/Entry with Invalid Account Number Initiated Under Questionable Circumstances|(1) Field(s) cannot be processed by RDFI; or  (2) the Entry contains an invalid DFI Account Number (account closed/no account/unable to locate account/invalid account number) and is believed by the RDFI to have been initiated under questionable circumstances.|RDFI|
|R18|Improper Effective Entry Date|(1) The Effective Entry Date for a credit Entry is more than two Banking Days after the Banking Day of processing as established by the Originating ACH Operator; or (2) the Effective Entry Date for a debit Entry is more than one Banking Day after the processing date.|ACH Operator|
|R19|Amount Field Error|(1) Amount field is non-numeric.  (2) Amount field is not zero in a Prenotification, DNE, ENR, Notification of Change, refused Notification of Change, or zero dollar CCD, CTX, or IAT Entry.(3) Amount field is zero in an Entry other than a Prenotification, DNE, ENR, Notification of Change, Return, dishonored Return, contested dishonored Return, or zero dollar CCD, CTX, or IAT Entry.(4) Amount field is greater than $25,000 for ARC, BOC, and POP Entries.|ACH Operator|
|R20|Non-Transaction Account|ACH Entry to a non-Transaction Account.|RDFI|
|R21|Invalid Company Identification|The Identification Number used in the Company Identification Field is not valid.|RDFI|
|R22|Invalid Individual ID Number|The Receiver has indicated to the RDFI that the number with which the Originator was identified is not correct.|RDFI|
|R23|Credit Entry Refused by Receiver|Any credit Entry that is refused by the Receiver may be returned by the RDFI.|RDFI|
|R24|Duplicate Entry|The RDFI has received what appears to be a duplicate Entry, i.e., the trace number, date, dollar amount and/or other data matches another transaction.|RDFI|
|R25|Addenda Error|Addenda Record Indicator value is incorrect.Addenda Type Code is invalid, out of sequence, or missing.Number of Addenda Records exceeds allowable maximum Addenda Sequence Number is invalid.|ACH Operator|
|R26|Mandatory Field Error|Erroneous data or missing data in a mandatory field.|ACH Operator|
|R27|Trace Number Error|(1) Original Entry Trace Number is not present in the Addenda Record on a Return or Notification of Change Entry; or (2) Trace Number of an Addenda Record is not the same as the Trace Number of the preceding Entry Detail Record.|ACH Operator|
|R28|Routing Number Check Digit Error|The check digit for a routing number is not valid.|ACH Operator|
|R29|Corporate Customer Advises Not Authorized|The RDFI has been notified by the Receiver (Non-Consumer) that a specific Entry has not been authorized by the Receiver.|RDFI|
|R30|RDFI Not Participant in Check Truncation Program|The RDFI does not participate in a Check Truncation Program.|ACH Operator|
|R31|Permissible Return Entry (CCD and CTX only)|The RDFI may return a CCD or CTX Entry that the ODFI agrees to accept.|RDFI|
|R32|RDFI Non-Settlement|The RDFI is not able to settle the Entry.|ACH Operator|
|R33|Return of XCK Entry|This Return Reason Code may only be used to return XCK Entries and is at the RDFI’s sole discretion.|RDFI|
|R34|Limited Participation DFI|The RDFI’s participation has been limited by a federal or state supervisor.|ACH Operator|
|R35|Return of Improper Debit Entry|Debit Entries (with the exception of Reversing Entries) are not permitted for CIE Entries or to loan accounts.|ACH Operator|
|R36|Return of Improper Credit Entry|ACH credit Entries (with the exception of Reversing Entries) are not permitted for use with ARC, BOC, POP, RCK, TEL, and XCK.|ACH Operator|
|R37|Source Document Presented for Payment|The source document to which an ARC, BOC, or POP Entry relates has been presented for payment.|RDFI|
|R38|Stop Payment on Source Document|The RDFI determines a stop payment order has been placed on the source document to which the ARC or BOC Entry relates.|RDFI|
|R39|Improper Source Document/Source Document Presented for Payment|The RDFI determines that:(1) the source document used for an ARC, BOC, or POP Entry to its Receiver’s account is improper, or (2) an ARC, BOC, or POP Entry relates have both been presented for payment and posted to the Receiver’s account.|RDFI|
|R40|Return of ENR Entry by Federal Government Agency|This Return Reason Code may only be used to return ENR Entries and is at the Federal Government Agency’s sole discretion.|Federal Government Agency|
|R41|Invalid Transaction Code|Either the Transaction Code included in Field 3 of the Addenda Record does not conform to the ACH Record Format Specifications contained in Appendix Three (ACH Record Format Specifications) or it is not appropriate regarding an Automated Enrollment Entry.|Federal Government Agency|
|R42|Routing Number/Check Digit Error|The Routing Number and the Check Digit included in Field 3 of the Addenda Record is either not a valid number or it does not conform to the Modulus 10 formula.|Federal Government Agency|
|R43|Invalid DFI Account Number|The Receiver’s account number included in Field 3 of the Addenda Record must include at least one alphameric character.|Federal Government Agency|
|R44|Invalid Individual ID Number/Identification Number|The Individual ID Number/Identification Number provided in Field 3 of the Addenda Record does not match a corresponding ID number in the Federal Government Agency’s records.|Federal Government Agency|
|R45|Invalid Individual Name/Company Name|The name of the consumer or company provided in Field 3 of the Addenda Record either does not match a corresponding name in the Federal Government Agency’s records or fails to include at least one alphameric character.|Federal Government Agency|
|R46|Invalid Representative Payee Indicator|The Representative Payee Indicator Code included in Field 3 of the Addenda Record has been omitted or it is not consistent with the Federal Government Agency’s records.|Federal Government Agency|
|R47|Duplicate Enrollment|The Entry is a duplicate of an Automated Enrollment Entry previously initiated by a DFI.|Federal Government Agency|
|R50|State Law Affecting RCK Acceptance|(1) The RDFI is located in a state that has not adopted Revised Article 4 of the Uniform Commercial Code (1990 Official Text) and has not revised its customer agreements to allow for electronic presentment; or (2) the RDFI is located within a state that requires all canceled Checks to a specific type of account to be returned to the Receiver within the periodic statement.|RDFI|
|R51|Item Related to RCK Entry Is Ineligible or RCK Entry Is Improper.|An RCK Entry is ineligible or improper.|RDFI|
|R52|Stop Payment on Item Related to RCK Entry|A stop payment order has been placed on the item to which the RCK Entry relates.|RDFI|
|R53|Item and RCK Entry Presented for Payment|In addition to an RCK Entry, the item to which the RCK Entry relates has also been presented for payment.|RDFI|


================================================================================
FILE: transaction-banking/ach-sec-codes.mdx
================================================================================

---
title: Supported Standard Entry Class (SEC) codes
keywords:
  - txb
  - transaction banking
---

## Supported Standard Entry Class (SEC) codes and their descriptions 
Below is a description of the Standard Entry Class (SEC) codes supported for ACH Credit and Debit transactions. The 3-character code is indicated in field 6 of the Company / Batch Header record (type 5). 

*Supported for both ACH Credits and ACH Debits:* <br/>

* <b>CCD (Corporate Debit or Credit entry)</b>: Used to facilitate commercial / business-to-business (B2B) payments between accounts belonging to the same or different business entities. They may be buyer-initiated (ACH Credit) or seller-initiated (ACH Debit) transactions. A CCD entry may have zero or one addenda record to contain supporting remittance information.<br/>
* <b>CTX (Corporate Trade Exchange entry)</b>: Also used to support commercial / trade related payments, that have extensive remittance information accompanying the payment. Each CTX entry can support up to a maximum of 9,999 addenda records each carrying 80 characters of information, formatted as an ANSI ASC X12 or UN/EDIFACT transaction.<br/>
* <b>PPD (Prearranged Payment and Deposit entry)</b>: Credit or debit entry originated by a non-consumer organization to a consumer account based on a standing or single-entry authorization from that consumer. Typical uses are for personal payments such as payroll, pension, dividend, etc., or for collection of bill payments for various purposes such as utility dues, insurance, loan payments, etc.<br/>
* <b>IAT (International ACH Transaction)</b>: A credit or debit USD ACH entry that is part of a larger cross-border transaction that involves a financial agency’s office outside the U.S. in the settlement of any leg of the cross-border transaction. <br/>

*Supported for ACH Debits only*: <br/>

* <b>WEB (Internet/Mobile initiated entry)</b>: Used by a non-consumer Originator to debit a consumer account, for recurring or non-recurring transactions, based on an authorization that is received other than by oral communication, i.e. via the internet or a wireless network. <br/>
* <b>TEL (Telephone initiated entry)</b>: An ACH debit entry to a consumer account, based on an authorization that is received by the Originator orally via the telephone. 


================================================================================
FILE: transaction-banking/ach-transaction-examples.mdx
================================================================================

---
title: ACH Transaction File Examples  
keywords:
  - txb
  - transaction banking
---




### Example 1:Domestic ACH Credit Transfer (CCD/PPD)

```

101 02601507911223344552006011330A094101GS BANK USA            YOUR COMPANY NAME      REF123AB
5220ALPHA COMPANY                       1234567890CCDPAYROLL   JUN 20200701   1026015070000001
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000001
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000002
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000003
822000000300333366660000000000000000003000001234567890                         026015070000001
5220ALPHA COMPANY                       1234567890PPDPAYROLL   JUN 20200701   1026015070000002
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000011
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000012
822000000200222244440000000000000000002000001234567890                         026015070000002
5220ALPHA COMPANY                       1234567890PPDPAYROLL   JUN 20200701   1026015070000003
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000101
632111122223123456789        0000100000AB156325       JACK SMITH              0026015070000102
822000000200222244440000000000000000002000001234567890                         026015070000003
9000003000002000000070077785554000000000000000000700000     


```

### Example 2:Domestic ACH Direct Debit (WEB/TEL)

```

101 02601507911223344552006011330A094101GS BANK USA            YOUR COMPANY NAME      REF123AB
5225ALPHA COMPANY                       1234567890WEBECOMM ORDRJUN 20200701   1026015070000001
637111122223123456789        0000100000AB156325       JACK SMITH              0026015070000001
637111122223123456789        0000100000AB156325       JACK SMITH              0026015070000002
637111122223123456789        0000100000AB156325       JACK SMITH              0026015070000003
822500000300333366660000003000000000000000001234567890                         026015070000001
5225ALPHA COMPANY                       1234567890TELGAS BILL  JUN 20200701   1026015070000003
637111122223123456789        0000100000AB156325       JACK SMITH              0026015070000101
637111122223123456789        0000100000AB156325       JACK SMITH              0026015070000102
822500000200222244440000002000000000000000001234567890                         026015070000003
9000002000002000000050055561110000000500000000000000000     


```

### Example 3:Inbound IAT Credit Transfer

```

101 02601507911223344552006011330A094101GS BANK USA            YOUR COMPANY NAME      REF123AB
5220                VF2FXREF-12345678 US0123456789IATMISC REMITGBPUSD201215   1026015070000001
6220212023370009             000001000012-2200-345-1                          1026015070000001
710MIS000000000000007185XXX-11110000          JOHN SMITH                               0000001
711JANE PETERSEN                      10 CHERRY LANE                                   0000001
712LONDON\                            GB*SW155PU\                                      0000001
713LLOYDS UK                          02LOYDGB2LXXX                       GB           0000001
714JP MORGAN CHASE BANK               01021202337                         US           0000001
715JSMITH-123     123 WALNUT STREET                                                    0000001
716SUMMIT*NJ\                         US*07960\                                        0000001
717CHRISTMAS GIFT                                                                  00010000001
718BARCLAYS BANK UK                   02BARCGB22                          GB       00030000001
82200000100026015070000000000000000000100000123456789                          026015070000001                         
9000001000002000000100002601507000000000000000000010000
   


```


================================================================================
FILE: transaction-banking/api-users.mdx
================================================================================

---
title: Use Cases
keywords:
  - txb
  - transaction banking
---

TxB APIs are designed to support two major use cases.

#### Direct users, e.g., corporate treasurers

Treasury Clients, who own a TxB deposit or escrow account or who use TxB payments services, can use
our APIs to build their treasury of the future, including automating payment execution and
reconciliation, liquidity tracking and forecasting, foreign exchange risk management, etc.

As an extension, TxB APIs can also be used by Treasury Management Systems, Accounting Systems, and
other solutions that corporate treasurers already use to manage their business. Building the
treasury of the future won't require every corporate treasurer to develop their treasury stack
in-house; many can leverage the powerful software already in the market. TxB can help extend the
capabilities of these types of service providers.

In addition to offering deposit accounts, typically used by corporate treasurers, we
also offer payments services that allow Clients to build payments capabilities into their internal
workflows. TxB payments services, powered by TxB APIs, are designed to allow any treasurer or
product team to streamline the payment experience without necessarily establishing a TxB deposit
account.

#### Payments & Banking as a Service, e.g., powering software our Clients offer to their end users

TxB APIs also allow software companies to leverage our financial infrastructure to build native
payments and banking experiences into their own customer facing applications.

An example use case might be:

- A software company offers a SaaS product to its business clients
- This company wants to enable their business clients to make payments, manage liquidity, and track
  foreign exchange rates from within their own mobile app
- This company could team up with TxB and use TxB APIs to power embedded banking experiences through
  its mobile app

<Grid layoutOption="oneColumn">
  <Block
    type="reference"
    title={'Learn how to create virtual accounts'}
    body={'Review how some of our functional domains work'}
    url={'/services/transaction-banking/create-via'} />
</Grid>


================================================================================
FILE: transaction-banking/auth-connection-part2.mdx
================================================================================

---
title: Step Up API Authentication
excludeFromSearch: true
---

If you haven't already done so, please read our Basic API Authentication Guide [here](/services/transaction-banking/auth-connection).

Basic information about JWT

- A JSON Web Token("JWT") is used by TxB partners who interact with our APIs on behalf of more than 1 client
- A JWT consists of a header, payload and a signature
- RSA key(private) with a unique 'kid' is used to sign the JWT. Partner exchanges public RSA key with TxB which will be used to validate the signature
- The claim in the payload has various identifiers namely, client(subject), partner(issuer), audience(txb), kid(from RSA key), sha256 hash of the mTLS cert

The guide below describes how to create and bind a JWT token, which may be included in the `Authentication` input parameter and which will be presented alongside the mTLS certificate.

## Step by Step Guide

#### Step 1 - Generate a public JWK using RSA KeyPair

Generate a one-time unique key ID:

```java
String uniqueKeyId = String.valueOf(UUID.randomUUID())
```

This unique key Id will be used in RSAKey generation (this step) and also used again in Step 3 during JWT generation.

You can use uuid generator tools to create this via code or via tools available online.

Generate public JWK using a one-time generated RSA Key:

```java
RSAKey rsaKey = new RSAKeyGenerator(2048)
    .keyUse(KeyUse.SIGNATURE) // indicate the intended use of the key
    .keyID(uniqueKeyId) //This static key Id will be used again in Step 3
    .generate();
return rsaKey.toPublicJWK();
```

This is a one-time key setup and will be used in Step 3 to sign the JWT.

Send the output of `rsaKey.toPublicJWK()` to TxB.

---

#### Step 2 - Calculate the certificate hash using thumbprint

Once you have the mTLS certificate, copy the text into the mTLSCert variable and run the code below to create the `X509Certificate` object

```java
String mTLSCert = "-----BEGIN CERTIFICATE-----\n"
                    +  "MIIFtzCCA5+gAwIBAgIRAJn6k32RASsmv/BtZ237xMAwDQYJKoZIhvcNAQELBQAw\n"
                    -----------------------------------------------------------------------
                    -----------------------------------------------------------------------
                    -----------------------------------------------------------------------
                    + "-----END CERTIFICATE-----\n";

InputStream targetStream = new ByteArrayInputStream(mTLSCert.getBytes());
CertificateFactory certificateFactory = CertificateFactory.getInstance("X.509");
X509Certificate x509cert = (X509Certificate) certificateFactory.generateCertificate(targetStream);
```

Compute the SHA256 hash of the `X509Certificate` object using below code:

```java
private static String getThumbprint(X509Certificate cert)
        throws NoSuchAlgorithmException, CertificateEncodingException {
    MessageDigest md = MessageDigest.getInstance("SHA-256");
    byte[] der = cert.getEncoded();
    md.update(der);
    byte[] digest = md.digest();
    String digestHex = DatatypeConverter.printHexBinary(digest);
    return digestHex.toLowerCase();
}

private static String calculateSHA256(X509Certificate x509cert) {
    String thumbprint = getThumbprint(x509cert);
    byte[] decodedHex = Hex.decodeHex(x509cert);
    return new String(Base64.getUrlEncoder().encode(
        decodedHex)).replaceAll("=+$", "");
}

```

An example output of the SHA256 hash is - `ikVs7R7oXt0Ll_EGWWCE6VaJv6myadr9giDODCzbvtM`. This value will be used in the JWT payload in step 3

---

#### Step 3 - Bind all of values together in JWT

Create a `JWTClaims` object:

```java
JwtClaims claims = new JwtClaims();
```

Set Expiration time on the claim:

```java
claims.setExpirationTimeMinutesInTheFuture(5);
```

Set the `Partner Identifier` provided by TxB:

```java
claims.setIssuer("0EAA62456B3426NU962A296BC4C5F9C9"); // This will be the gseid value in the mTLS cert
```

Set the `Client Identifier` provided by TxB:

```java
claims.setSubject("7FNA456B34268NU6G9682A2964C5967F"); // This value will change based on the third party account
```

Set the audience as `txb`:

```java
claims.setAudience("txb");
```

Set a random ID for JWTId:

```java
claims.setJwtId(String.valueOf(UUID.randomUUID()));
```

Set Current time as `issuedAt` time:

```java
claims.setIssuedAtToNow();
```

Set value of `kid` from Step 1:

```java
claims.setClaim("kid", uniqueKeyId);
```

Set `cnf#x5t#S256` from output of Step 2:

```java
claims.setClaim("cnf#x5t#S256", calculateSHA256(x509cert));
```

Sign the JWT using the RSAKey from Step 1:

```java
JsonWebSignature jws = new JsonWebSignature();
jws.setPayload(claims.toJson());
jws.setAlgorithmHeaderValue(AlgorithmIdentifiers.RSA_USING_SHA256);
jws.setKey(rsaKey.toPrivateKey()); // From Step 1
jws.setDoKeyValidation(false); // relaxes the key length requirement
```

Finally, return the JWT Output:

```java
String jwtOut = jws.getCompactSerialization();
return jwtOut;
```

Your JWT will look something like this:

```java
eyJhbGciOiJSUzI1NiJ9.eyJleHAiOjE2MDEyNjMyNzgsInN1YiI6IjdGTkE0NTZCMzQyNjhOVTZHOTY4MkEyOTY0QzU5NjdGIiwiYXVkIjoidHhiIiwianRpIjoiYjI5NGMxZjMtY2Y3OC00OTU4LWI3OGMtYTM0ZGE5MDhlMGM3IiwiaXNzIjoiMEVBQTYyNDU2QjM0MjZOVTk2MkEyOTZCQzRDNUY5QzkiLCJpYXQiOjE2MDEyNjI5NzgsImtpZCI6ImFlODVmZWU0LWQ5OGQtNGI4NS1iMDM0LTI5ZTgzMGE5ZjA0NyIsImNuZiN4NXQjUzI1NiI6ImlrVnM3UjdvWHQwTGxfRUdXV0NFNlZhSnY2bXlhZHI5Z2lET0RDemJ2dE0ifQ.fFuBynWjCcsmvye0kbI-ZAIqEXrLqvv9BFU13ZRoKcf54sQTUaguMubVQP4u1S1IijxyUMrFJpygzjbBQL_xzVRaUVXTPlrYM8HlugjsE-t94D085Y9ULJmDNbsGALwnA5ftv0O3cUH7qckmtIvUWI58vH6BvMYoS6T4ANiwXNxux7d81bGqy7r4a-IJH1umCLaz-cprhyb8J5SJkNhx4m5CJWGIyg5ycpF0PNUDX3HjxcACilXPQMGAKtQkV89EzzGFDc-j46aQ0920ocf9u_LfmavfYABasEtX9E0j8TKnAS1RZosKoCbj14OV8sYhNgKm9BIvk32aS2VfwpkMfQ

```

---

#### Step 4 - Test final connection

Finally, test your connection using this cURL command:

```c

curl -s -X GET "https://api.test.txb.gs.com/v1/connectivity" -H "Authorization: Bearer <jwtOut>" --cacert ./certificate.pem --key private_key.key


```


================================================================================
FILE: transaction-banking/auth-connection.mdx
================================================================================

---
title: Basic API Authentication
excludeFromSearch: true
---

TxB APIs are authenticated with mutual TLS and IP allowlisting.

In this example, we assume you are a client of TxB's and want to create an API connection to perform operations on your own account(s). We also support the ability to securely perform operations on other clients' accounts where express permission is granted.

## Step by Step Guide

[...]
